use LWP::Simple;

###################################################################################################################################
# You run the code by typing at the command line:
# perl CrawlerNewYorkTimeSections.pl SourceFile.txt TargetFile.txt Year0 Year1 OutputFile.txt
# SourceFile.txt is a column of text with the names of items to be queried 
# TargetFile.txt is a column of text with the names of the items to be queried againts
# Year0 is the starting year of the observation window
# Year1 is the final year of the observation window
# OutputFile.txt is the name of the file where the output will be written
###################################################################################################################################

print STDERR "********************************** \n";
print STDERR "WELCOME TO THE API-309 WebCrawler  \n";
print STDERR "********************************** \n";

open(TARGETS,$ARGV[0]);
open(ALL,$ARGV[1]);

$i=0;
while(<TARGETS>)
{
	chomp;
	@data=split(/\t/,$_);
	#print STDERR "$data[0] ...  $data[1] ..... $data[2] \n";
	$target[$i]=$data[0];
	$TARGET{$data[0]}=1;
	#$indextarget[$i]=$data[1];
	#$sectortarget[$i]=$data[2];	
	$i++;
}
$i=0;

while(<ALL>)
{
	chomp;
	@data=split(/\t/,$_);
	$all[$i]=$data[0];
	#$indexall[$i]=$data[1];
	#$sectorall[$i]=$data[2];		
	$i++;
}

$T=scalar(@target);
$A=scalar(@all);

$year0=$ARGV[2];
$year1=$ARGV[3];

open(OUTPUT,">$ARGV[4]");

print STDERR "$year0 $year1\n";
print OUTPUT "TARGET\tCANDIDATE\tTOTAL\tArts\tAutomobiles\tBooks\tBusiness\tCorrections\tDiningAndWine\tEditorsNotes\tEducation\tFrontPage\tHealth\tHomeAndGarden\tJobMarket\tMagazine\tMovies\tNewYorkAndRegion\tObituaries\tOpinion\tRealState\tScience\tSports\tStyle\tTechnology\tThePublicEditor\tTheater\tTravel\tUS\tWashington\tWeekInReview\tWorld";

for ($i=0;$i<$T;$i++)
{
	 
	for ($j=0;$j<$A;$j++)
	{	
		#################### Do Query  ################
 		
		if (exists($LINKREVERSE{$target[$i]}{$all[$j]}))
		{
			print STDERR "Skipping $target[$i] with $all[$j] .. it is redundant\n";
			next;	
		}
		
		$LINKREVERSE{$all[$j]}{$target[$i]}=1;
		
		print STDERR "processing $i with $j (";  ### added Luigi ##
		print STDERR "$target[$i] with $all[$j])\n";
		
		$Query="http\:\/\/query\.nytimes\.com\/search\/query\?frow\=0\&n\=10\&srcht\=a\&query\=\%22"."$target[$i]"."\%22\+\%22"."$all[$j]"."\%22\&srchst\=nyt\&submit\.x\=38\&submit\.y\=9\&submit\=sub\&hdlquery\=\&bylquery\=\&daterange\=period\&mon1\=01\&day1\=01\&year1\="."$year0"."\&mon2\=12\&day2\=31\&year2\="."$year1";
		
		$File0=get($Query); ### changed file with file0 to uniform the 2 codes Luigi ##
		
		### copied 1 start  ##
		print OUTPUT "\n";
		
		$TIMEOUT=0;
		
		if (defined($File0))
		{
		print STDERR "File retrieved... :-)\n";
		}
		else
		{
			while($TIMEOUT==0)
			{
				$File0=get($Query); ### changed file with file0 to uniform the 2 codes Luigi ##
				print STDERR "Timed out\n";
				
				if (defined($File0))
				{
				$TIMEOUT=1;
				}
			}
		}
		
				
		$File1=$File0;$File2=$File0;$File3=$File0;
		$File4=$File0;$File5=$File0;$File6=$File0;
		$File7=$File0;$File8=$File0;$File9=$File0;
		$File10=$File0;$File11=$File0;$File12=$File0;
		$File13=$File0;$File14=$File0;$File15=$File0;
		$File16=$File0;$File17=$File0;$File18=$File0;
		$File19=$File0;$File20=$File0;$File21=$File0;
		$File22=$File0;$File23=$File0;$File24=$File0;
		$File25=$File0;$File26=$File0;$File27=$File0;
		$File28=$File0;$File29=$File0;$File30=$File0;
		
		$foundsomething=0;
		
		print OUTPUT "$target[$i]\t$all[$j]"; 
		print OUTPUT "\t";
		
		
		### copied 1 Finish ##
	
		################### Filter Results ############
				
		if ($File0 =~ /(of.*Results)/)
		{
			@data=split(/\s/,$1);
			$data[1] =~ s/,//; ### is it necessary to add the g in the end of the row?? Luigi##
			$NumberOfHits=$data[1];
			$foundsomething=1; ###luigi foundsomething add##
			print STDERR "$NumberOfHits\n";
			print OUTPUT "$NumberOfHits\t"; ###luigi changed the last n in a t and canceled $target[$i]\t $all[$j]\t  if it is above  ##
			
		}
		elsif ($File0 =~ /returned 0 results.\<\/span\>\<\/li\>/)
		{
			print STDERR "empty page\n";
			print STDERR "$target[$i]\t $all[$j]\t 0\n";
			print OUTPUT "0\t"; ###luigi changed the last n in a t and canceled $target[$i]\t $all[$j]\t  if it is above  ##
		}
		
		###Luigi Adding##
		if ($foundsomething == 1)
			{
			
				##Arts2##
					if ($File2 =~ /(refinement\(\"Arts\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits2=$data[3];
						print STDERR "Arts $NumberOfHits2\n";
						print OUTPUT "$NumberOfHits2\t";
					
					}
					else
					{
						print STDERR "no Arts\n";
						print OUTPUT "0\t";
					}
				##Automobiles3##
					if ($File3 =~ /(refinement\(\"Automobiles\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits3=$data[3];
						print STDERR "Automobiles $NumberOfHits3\n";
						print OUTPUT "$NumberOfHits3\t";
					
					}
					else
					{
						print STDERR "no Automobiles\n";
						print OUTPUT "0\t";
					}
				##Books4##
					if ($File4 =~ /(refinement\(\"Books\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits4=$data[3];
						print STDERR "Books $NumberOfHits4\n";
						print OUTPUT "$NumberOfHits4\t";
					
					}
					else
					{
						print STDERR "no Books\n";
						print OUTPUT "0\t";
					}
				##Business5##
					if ($File5 =~ /(refinement\(\"Business\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits5=$data[3];
						print STDERR "Business $NumberOfHits5\n";
						print OUTPUT "$NumberOfHits5\t";
					
					}
					else
					{
						print STDERR "no Business\n";
						print OUTPUT "0\t";
					}
				##Corrections6##
					if ($File6 =~ /(refinement\(\"Corrections\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits6=$data[3];
						print STDERR "Corrections $NumberOfHits6\n";
						print OUTPUT "$NumberOfHits6\t";
					
					}
					else
					{
						print STDERR "no Corrections\n";
						print OUTPUT "0\t";
					}
				##Dining and Wine7##
					if ($File7 =~ /(refinement\(\"Dining and Wine\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits7=$data[3];
						print STDERR "Dining and Wine $NumberOfHits7\n";
						print OUTPUT "$NumberOfHits7\t";
					
					}
					else
					{
						print STDERR "no Dining and Wine\n";
						print OUTPUT "0\t";
					}
				##Editors' Notes8##
					if ($File8 =~ /(refinement\(\"Editors' Notes\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits8=$data[3];
						print STDERR "Editors' Notes $NumberOfHits8\n";
						print OUTPUT "$NumberOfHits8\t";
					
					}
					else
					{
						print STDERR "no Editors' Notes\n";
						print OUTPUT "0\t";
					}
				##Education9##
					if ($File9 =~ /(refinement\(\"Education\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits9=$data[3];
						print STDERR "Education $NumberOfHits9\n";
						print OUTPUT "$NumberOfHits9\t";
					
					}
					else
					{
						print STDERR "no Education\n";
						print OUTPUT "0\t";
					}
				##Front Page10##
					if ($File10 =~ /(refinement\(\"Front Page\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits10=$data[3];
						print STDERR "Front Page $NumberOfHits10\n";
						print OUTPUT "$NumberOfHits10\t";
					
					}
					else
					{
						print STDERR "no Front Page\n";
						print OUTPUT "0\t";
					}
				##Health11##
					if ($File11 =~ /(refinement\(\"Health\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits11=$data[3];
						print STDERR "Health $NumberOfHits11\n";
						print OUTPUT "$NumberOfHits11\t";
					
					}
					else
					{
						print STDERR "no Health\n";
						print OUTPUT "0\t";
					}
				##Home and Garden12##
					if ($File12 =~ /(refinement\(\"Home and Garden\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits12=$data[3];
						print STDERR "Home and Garden $NumberOfHits12\n";
						print OUTPUT "$NumberOfHits12\t";
					
					}
					else
					{
						print STDERR "no Home and Garden\n";
						print OUTPUT "0\t";
					}
				##Job Market13##
					if ($File13 =~ /(refinement\(\"Job Market\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits13=$data[3];
						print STDERR "Job Market $NumberOfHits13\n";
						print OUTPUT "$NumberOfHits13\t";
					
					}
					else
					{
						print STDERR "no Job Market\n";
						print OUTPUT "0\t";
					}
				##Magazine14##
					if ($File14 =~ /(refinement\(\"Magazine\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits14=$data[3];
						print STDERR "Magazine $NumberOfHits14\n";
						print OUTPUT "$NumberOfHits14\t";
					
					}
					else
					{
						print STDERR "no Magazine\n";
						print OUTPUT "0\t";
					}
				##Movies15##
					if ($File15 =~ /(refinement\(\"Movies\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits15=$data[3];
						print STDERR "Movies $NumberOfHits15\n";
						print OUTPUT "$NumberOfHits15\t";
					
					}
					else
					{
						print STDERR "no Movies\n";
						print OUTPUT "0\t";
					}
				##New York and Region16##
					if ($File16 =~ /(refinement\(\"New York and Region\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits16=$data[3];
						print STDERR "New York and Region $NumberOfHits16\n";
						print OUTPUT "$NumberOfHits16\t";
					
					}
					else
					{
						print STDERR "no New York and Region\n";
						print OUTPUT "0\t";
					}
				##Obituaries17##
					if ($File17 =~ /(refinement\(\"Obituaries\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits17=$data[3];
						print STDERR "Obituaries $NumberOfHits17\n";
						print OUTPUT "$NumberOfHits17\t";
					
					}
					else
					{
						print STDERR "no Obituaries\n";
						print OUTPUT "0\t";
					}
				##Opinion18##
					if ($File18 =~ /(refinement\(\"Opinion\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits18=$data[3];
						print STDERR "Opinion $NumberOfHits18\n";
						print OUTPUT "$NumberOfHits18\t";
						
					}
					else
					{
						print STDERR "no Opinion\n";
						print OUTPUT "0\t";
					}
				##Real Estate19##
					if ($File19 =~ /(refinement\(\"Real Estate\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits19=$data[3];
						print STDERR "Real Estate $NumberOfHits19\n";
						print OUTPUT "$NumberOfHits19\t";
					
					}
					else
					{
						print STDERR "no Real Estate\n";
						print OUTPUT "0\t";
					}
				##Science20##
					if ($File20 =~ /(refinement\(\"Science\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits20=$data[3];
						print STDERR "Science $NumberOfHits20\n";
						print OUTPUT "$NumberOfHits20\t";
					
					}
					else
					{
						print STDERR "no Science\n";
						print OUTPUT "0\t";
					}
				##Sports21##
					if ($File21 =~ /(refinement\(\"Sports\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits21=$data[3];
						print STDERR "Sports $NumberOfHits21\n";
						print OUTPUT "$NumberOfHits21\t";
					
					}
					else
					{
						print STDERR "no Sports\n";
						print OUTPUT "0\t";
					}
				##Style22##
					if ($File22 =~ /(refinement\(\"Style\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits22=$data[3];
						print STDERR "Style $NumberOfHits22\n";
						print OUTPUT "$NumberOfHits22\t";
					
					}
					else
					{
						print STDERR "no Style\n";
						print OUTPUT "0\t";
					}
				##Technology23##
					if ($File23 =~ /(refinement\(\"Technology\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits23=$data[3];
						print STDERR "Technology $NumberOfHits23\n";
						print OUTPUT "$NumberOfHits23\t";
					
					}
					else
					{
						print STDERR "no Technology\n";
						print OUTPUT "0\t";
					}
				##The Public Editor24##
					if ($File24 =~ /(refinement\(\"The Public Editor\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits24=$data[3];
						print STDERR "The Public Editor $NumberOfHits24\n";
						print OUTPUT "$NumberOfHits24\t";
					
					}
					else
					{
						print STDERR "no The Public Editor\n";
						print OUTPUT "0\t";
					}
					##Theater25##
					if ($File25 =~ /(refinement\(\"Theater\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits25=$data[3];
						print STDERR "Theater $NumberOfHits25\n";
						print OUTPUT "$NumberOfHits25\t";
					
					}
					else
					{
						print STDERR "no Theater\n";
						print OUTPUT "0\t";
					}
				##Travel26##
					if ($File26 =~ /(refinement\(\"Travel\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits26=$data[3];
						print STDERR "Travel $NumberOfHits26\n";
						print OUTPUT "$NumberOfHits26\t";
					
					}
					else
					{
						print STDERR "no Travel\n";
						print OUTPUT "0\t";
					}
				##U.S.27##
					if ($File27 =~ /(refinement\(\"U.S.\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits27=$data[3];
						print STDERR "U.S. $NumberOfHits27\n";
						print OUTPUT "$NumberOfHits27\t";
					
					}
					else
					{
						print STDERR "no U.S.\n";
						print OUTPUT "0\t";
					}
				##Washington28##
					if ($File28 =~ /(refinement\(\"Washington\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits28=$data[3];
						print STDERR "Washington $NumberOfHits28\n";
						print OUTPUT "$NumberOfHits28\t";
					
					}
					else
					{
						print STDERR "no Washington\n";
						print OUTPUT "0\t";
					}
				##Week in Review29##
					if ($File29 =~ /(refinement\(\"Week in Review\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits29=$data[3];
						print STDERR "Week in Review $NumberOfHits29\n";
						print OUTPUT "$NumberOfHits29\t";
					
					}
					else
					{
						print STDERR "no Week in Review\n";
						print OUTPUT "0\t";
					}
				##World30##
					if ($File30 =~ /(refinement\(\"World\"\, \".*\"\,)/)
					{
						@data=split(/\"/,$1);
						$data[3] =~ s/,//g;
						$NumberOfHits30=$data[3];
						print STDERR "World $NumberOfHits30\n";
						print OUTPUT "$NumberOfHits30\t";
					
					}
					else
					{
						print STDERR "no World\n";
						print OUTPUT "0\t";
					}

			
					
					
				}
				undef($File0);
		
			
	}
}